"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _TextInput = require("@patternfly/react-core/dist/js/components/TextInput/TextInput.js");

var _InputGroup = require("@patternfly/react-core/dist/js/components/InputGroup/InputGroup.js");

var _Bullseye = require("@patternfly/react-core/dist/js/layouts/Bullseye/Bullseye.js");

var _Button = require("@patternfly/react-core/dist/js/components/Button/Button.js");

var _Flex = require("@patternfly/react-core/dist/js/layouts/Flex/Flex.js");

var _FlexItem = require("@patternfly/react-core/dist/js/layouts/Flex/FlexItem.js");

var _Grid = require("@patternfly/react-core/dist/js/layouts/Grid/Grid.js");

var _GridItem = require("@patternfly/react-core/dist/js/layouts/Grid/GridItem.js");

var _Text = require("@patternfly/react-core/dist/js/components/Text/Text.js");

var _TextContent = require("@patternfly/react-core/dist/js/components/Text/TextContent.js");

var _Toolbar = require("@patternfly/react-core/dist/js/components/Toolbar/Toolbar.js");

var _ToolbarItem = require("@patternfly/react-core/dist/js/components/Toolbar/ToolbarItem.js");

var _ToolbarContent = require("@patternfly/react-core/dist/js/components/Toolbar/ToolbarContent.js");

var _pficonSortCommonAscIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/pficon-sort-common-asc-icon"));

var _pficonSortCommonDescIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/pficon-sort-common-desc-icon"));

var _searchIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/search-icon"));

var _angleDoubleLeftIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/angle-double-left-icon"));

var _angleDoubleRightIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/angle-double-right-icon"));

var _angleRightIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/angle-right-icon"));

var _angleLeftIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/angle-left-icon"));

require("./dual-list-select.scss");

var _dualListSelect2 = _interopRequireDefault(require("@data-driven-forms/common/dual-list-select"));

var _formGroup = _interopRequireDefault(require("../form-group/form-group"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var List = function List(_ref) {
  var value = _ref.value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      ListProps = _ref.ListProps,
      ListItemProps = _ref.ListItemProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["value", "optionClick", "noOptionsTitle", "filterValue", "filterValueText", "selectedValues", "ListProps", "ListItemProps"]);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, ListProps, rest, {
    className: (0, _clsx["default"])('pf-c-form-control', 'pf-u-pr-sm ddorg__pf4-component-mapper__dual-list-select', ListProps.className)
  }), value.length < 1 && /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, ListItemProps, {
    className: (0, _clsx["default"])('ddorg__pf4-component-mapper__dual-list-select-option-text', 'ddorg__pf4-component-mapper__dual-list-select-option-disabled', ListItemProps.className)
  }), filterValue ? filterValueText : noOptionsTitle), value.length > 0 && value.map(function (_ref2) {
    var value = _ref2.value,
        label = _ref2.label,
        ListItemPropsItem = _ref2.ListItemProps;
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      onClick: function onClick(e) {
        return optionClick(e, value);
      },
      key: value,
      value: value
    }, ListItemProps, ListItemPropsItem, {
      className: (0, _clsx["default"])('ddorg__pf4-component-mapper__dual-list-select-option', {
        'ddorg__pf4-component-mapper__dual-list-select-option-selected': selectedValues.includes(value)
      }, ListItemProps.className, ListItemPropsItem === null || ListItemPropsItem === void 0 ? void 0 : ListItemPropsItem.className)
    }), label);
  }));
};

List.propTypes = {
  value: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].string.isRequired,
    label: _propTypes["default"].string.isRequired
  })),
  optionClick: _propTypes["default"].func.isRequired,
  noOptionsTitle: _propTypes["default"].node,
  filterValue: _propTypes["default"].string,
  filterValueText: _propTypes["default"].node,
  selectedValues: _propTypes["default"].array,
  ListProps: _propTypes["default"].object,
  ListItemProps: _propTypes["default"].object
};
List.defaultProps = {
  value: [],
  ListProps: {}
};

var InternalToolbar = function InternalToolbar(_ref3) {
  var sortTitle = _ref3.sortTitle,
      onFilter = _ref3.onFilter,
      onSort = _ref3.onSort,
      sortDirection = _ref3.sortDirection,
      value = _ref3.value,
      placeholder = _ref3.placeholder,
      id = _ref3.id,
      ToolbarProps = _ref3.ToolbarProps,
      SideToolbarProps = _ref3.SideToolbarProps,
      FilterFieldProps = _ref3.FilterFieldProps,
      SideFilterFieldProps = _ref3.SideFilterFieldProps,
      SearchIconButtonProps = _ref3.SearchIconButtonProps,
      SideSearchIconButtonProps = _ref3.SideSearchIconButtonProps,
      SearchIconProps = _ref3.SearchIconProps,
      SideSearchIconProps = _ref3.SideSearchIconProps,
      SortIconButtonProps = _ref3.SortIconButtonProps,
      SideSortIconButtonProps = _ref3.SideSortIconButtonProps,
      SortIconProps = _ref3.SortIconProps,
      SideSortIconProps = _ref3.SideSortIconProps;
  return /*#__PURE__*/_react["default"].createElement(_Toolbar.Toolbar, (0, _extends2["default"])({}, ToolbarProps, SideToolbarProps, {
    className: (0, _clsx["default"])('pf-u-p-0', 'ddorg__pf4-component-mapper__dual-list-select-toolbar', ToolbarProps && ToolbarProps.className, SideToolbarProps && SideToolbarProps.className),
    id: id
  }), /*#__PURE__*/_react["default"].createElement(_ToolbarContent.ToolbarContent, {
    className: "pf-u-p-0 pf-u-pb-md"
  }, /*#__PURE__*/_react["default"].createElement(_ToolbarItem.ToolbarItem, {
    className: "ddorg__pf4-component-mapper__dual-list-select-toolbar__item-grow"
  }, /*#__PURE__*/_react["default"].createElement(_InputGroup.InputGroup, null, /*#__PURE__*/_react["default"].createElement(_TextInput.TextInput, (0, _extends2["default"])({
    name: "filterOptions",
    id: "filterOptions",
    type: "search",
    "aria-label": placeholder,
    onChange: onFilter,
    placeholder: placeholder,
    value: value
  }, FilterFieldProps, SideFilterFieldProps)), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    variant: _Button.ButtonVariant.control,
    "aria-label": "search button"
  }, SearchIconButtonProps, SideSearchIconButtonProps), /*#__PURE__*/_react["default"].createElement(_searchIcon["default"], (0, _extends2["default"])({}, SearchIconProps, SideSearchIconProps))))), /*#__PURE__*/_react["default"].createElement(_ToolbarItem.ToolbarItem, null, /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    onClick: onSort,
    title: sortTitle,
    variant: "plain"
  }, SortIconButtonProps, SideSortIconButtonProps), !sortDirection ? /*#__PURE__*/_react["default"].createElement(_pficonSortCommonAscIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, SortIconProps, SideSortIconProps)) : /*#__PURE__*/_react["default"].createElement(_pficonSortCommonDescIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, SortIconProps, SideSortIconProps))))));
};

InternalToolbar.propTypes = {
  sortTitle: _propTypes["default"].node,
  onFilter: _propTypes["default"].func.isRequired,
  onSort: _propTypes["default"].func.isRequired,
  sortDirection: _propTypes["default"].bool,
  value: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  id: _propTypes["default"].string,
  ToolbarProps: _propTypes["default"].object,
  SideToolbarProps: _propTypes["default"].object,
  FilterFieldProps: _propTypes["default"].object,
  SideFilterFieldProps: _propTypes["default"].object,
  SearchIconProps: _propTypes["default"].object,
  SideSearchIconProps: _propTypes["default"].object,
  SearchIconButtonProps: _propTypes["default"].object,
  SideSearchIconButtonProps: _propTypes["default"].object,
  SortIconButtonProps: _propTypes["default"].object,
  SideSortIconButtonProps: _propTypes["default"].object,
  SortIconProps: _propTypes["default"].object,
  SideSortIconProps: _propTypes["default"].object
};

var DualList = function DualList(_ref4) {
  var meta = _ref4.meta,
      input = _ref4.input,
      allToRight = _ref4.allToRight,
      allToLeft = _ref4.allToLeft,
      leftTitle = _ref4.leftTitle,
      moveAllLeftTitle = _ref4.moveAllLeftTitle,
      moveAllRightTitle = _ref4.moveAllRightTitle,
      moveRightTitle = _ref4.moveRightTitle,
      moveLeftTitle = _ref4.moveLeftTitle,
      rightTitle = _ref4.rightTitle,
      label = _ref4.label,
      isRequired = _ref4.isRequired,
      helperText = _ref4.helperText,
      noValueTitle = _ref4.noValueTitle,
      noOptionsTitle = _ref4.noOptionsTitle,
      filterOptionsTitle = _ref4.filterOptionsTitle,
      filterValueTitle = _ref4.filterValueTitle,
      filterValueText = _ref4.filterValueText,
      filterOptionsText = _ref4.filterOptionsText,
      state = _ref4.state,
      description = _ref4.description,
      id = _ref4.id,
      hideLabel = _ref4.hideLabel,
      sortOptions = _ref4.sortOptions,
      filterOptions = _ref4.filterOptions,
      handleOptionsClick = _ref4.handleOptionsClick,
      leftValues = _ref4.leftValues,
      handleMoveRight = _ref4.handleMoveRight,
      handleMoveLeft = _ref4.handleMoveLeft,
      handleClearLeftValues = _ref4.handleClearLeftValues,
      handleClearRightValues = _ref4.handleClearRightValues,
      sortValues = _ref4.sortValues,
      filterValues = _ref4.filterValues,
      rightValues = _ref4.rightValues,
      handleValuesClick = _ref4.handleValuesClick,
      renderStatus = _ref4.renderStatus,
      FormGroupProps = _ref4.FormGroupProps,
      ListProps = _ref4.ListProps,
      LeftListProps = _ref4.LeftListProps,
      RightListProps = _ref4.RightListProps,
      ListItemProps = _ref4.ListItemProps,
      LeftListItemProps = _ref4.LeftListItemProps,
      RightListItemProps = _ref4.RightListItemProps,
      ToolbarProps = _ref4.ToolbarProps,
      LeftToolbarProps = _ref4.LeftToolbarProps,
      RightToolbarProps = _ref4.RightToolbarProps,
      FilterFieldProps = _ref4.FilterFieldProps,
      LeftFilterFieldProps = _ref4.LeftFilterFieldProps,
      RightFilterFieldProps = _ref4.RightFilterFieldProps,
      SearchIconProps = _ref4.SearchIconProps,
      LeftSearchIconProps = _ref4.LeftSearchIconProps,
      RightSearchIconProps = _ref4.RightSearchIconProps,
      SearchIconButtonProps = _ref4.SearchIconButtonProps,
      LeftSearchIconButtonProps = _ref4.LeftSearchIconButtonProps,
      RightSearchIconButtonProps = _ref4.RightSearchIconButtonProps,
      SortIconButtonProps = _ref4.SortIconButtonProps,
      LeftSortIconButtonProps = _ref4.LeftSortIconButtonProps,
      RightSortIconButtonProps = _ref4.RightSortIconButtonProps,
      SortIconProps = _ref4.SortIconProps,
      LeftSortIconProps = _ref4.LeftSortIconProps,
      RightSortIconProps = _ref4.RightSortIconProps,
      InternalGridProps = _ref4.InternalGridProps,
      ListGridProps = _ref4.ListGridProps,
      LeftListGridProps = _ref4.LeftListGridProps,
      RightListGridProps = _ref4.RightListGridProps,
      TitleProps = _ref4.TitleProps,
      LeftTitleProps = _ref4.LeftTitleProps,
      RightTitleProps = _ref4.RightTitleProps,
      ButtonsGridProps = _ref4.ButtonsGridProps,
      ButtonsInternalFlexProps = _ref4.ButtonsInternalFlexProps,
      ButtonFlexProps = _ref4.ButtonFlexProps,
      ToRightFlexProps = _ref4.ToRightFlexProps,
      IconButtonProps = _ref4.IconButtonProps,
      ToRightIconButtonProps = _ref4.ToRightIconButtonProps,
      IconProps = _ref4.IconProps,
      AllToRightFlexProps = _ref4.AllToRightFlexProps,
      AllToRightIconButtonProps = _ref4.AllToRightIconButtonProps,
      AllToLeftFlexProps = _ref4.AllToLeftFlexProps,
      AllToLeftIconButtonProps = _ref4.AllToLeftIconButtonProps,
      ToLeftFlexProps = _ref4.ToLeftFlexProps,
      ToLeftIconButtonProps = _ref4.ToLeftIconButtonProps,
      ToRightIconProps = _ref4.ToRightIconProps,
      AllToRightIconProps = _ref4.AllToRightIconProps,
      AllToLeftIconProps = _ref4.AllToLeftIconProps,
      ToLeftIconProps = _ref4.ToLeftIconProps;
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    description: description,
    hideLabel: hideLabel,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/_react["default"].createElement(_Grid.Grid, InternalGridProps, /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, (0, _extends2["default"])({
    md: 5
  }, ListGridProps, LeftListGridProps), /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, (0, _extends2["default"])({}, TitleProps, LeftTitleProps), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    component: _Text.TextVariants.h6
  }, leftTitle))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(InternalToolbar, {
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    onFilter: filterOptions,
    value: state.filterOptions,
    placeholder: filterOptionsTitle,
    id: "".concat(input.name, "-options-toolbar"),
    ToolbarProps: ToolbarProps,
    SideToolbarProps: LeftToolbarProps,
    FilterFieldProps: FilterFieldProps,
    SideFilterFieldProps: LeftFilterFieldProps,
    SearchIconProps: SearchIconProps,
    SideSearchIconProps: LeftSearchIconProps,
    SearchIconButtonProps: SearchIconButtonProps,
    SideSearchIconButtonProps: LeftSearchIconButtonProps,
    SortIconButtonProps: SortIconButtonProps,
    SideSortIconButtonProps: LeftSortIconButtonProps,
    SortIconProps: SortIconProps,
    SideSortIconProps: LeftSortIconProps
  })), renderStatus && /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    "data-test-id": "left-status-text",
    component: _Text.TextVariants.h6
  }, renderStatus({
    selected: state.selectedLeftValues.length,
    options: leftValues.length
  })))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(List, {
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues,
    ListProps: _objectSpread(_objectSpread({}, ListProps), LeftListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), LeftListItemProps)
  })))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, (0, _extends2["default"])({
    md: 2
  }, ButtonsGridProps), /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, {
    className: "ddorg__pf4-component-mapper__dual-list-select-buttons"
  }, /*#__PURE__*/_react["default"].createElement(_Flex.Flex, (0, _extends2["default"])({
    direction: {
      md: 'column',
      sm: 'row'
    }
  }, ButtonsInternalFlexProps), /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, (0, _extends2["default"])({}, ButtonFlexProps, ToRightFlexProps), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    disabled: leftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle,
    variant: "plain"
  }, IconButtonProps, ToRightIconButtonProps), /*#__PURE__*/_react["default"].createElement(_angleRightIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, IconProps, ToRightIconProps)))), allToRight && /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, (0, _extends2["default"])({}, ButtonFlexProps, AllToRightFlexProps), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle,
    variant: "plain"
  }, IconButtonProps, AllToRightIconButtonProps), /*#__PURE__*/_react["default"].createElement(_angleDoubleRightIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, IconProps, AllToRightIconProps)))), allToLeft && /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, (0, _extends2["default"])({}, ButtonFlexProps, AllToLeftFlexProps), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle,
    variant: "plain"
  }, IconButtonProps, AllToLeftIconButtonProps), /*#__PURE__*/_react["default"].createElement(_angleDoubleLeftIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, IconProps, AllToLeftIconProps)))), /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, (0, _extends2["default"])({}, ButtonFlexProps, ToLeftFlexProps), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    disabled: rightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle,
    variant: "plain"
  }, IconButtonProps, ToLeftIconButtonProps), /*#__PURE__*/_react["default"].createElement(_angleLeftIcon["default"], (0, _extends2["default"])({
    size: "md"
  }, IconProps, ToLeftIconProps))))))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, (0, _extends2["default"])({
    md: 5
  }, ListGridProps, RightListGridProps), /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, (0, _extends2["default"])({}, TitleProps, RightTitleProps), /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    component: _Text.TextVariants.h6
  }, rightTitle))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(InternalToolbar, {
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    onFilter: filterValues,
    value: state.filterValue,
    placeholder: filterValueTitle,
    id: "".concat(input.name, "-value-toolbar"),
    ToolbarProps: ToolbarProps,
    SideToolbarProps: RightToolbarProps,
    FilterFieldProps: FilterFieldProps,
    SideFilterFieldProps: RightFilterFieldProps,
    SearchIconProps: SearchIconProps,
    SideSearchIconProps: RightSearchIconProps,
    SearchIconButtonProps: SearchIconButtonProps,
    SideSearchIconButtonProps: RightSearchIconButtonProps,
    SortIconButtonProps: SortIconButtonProps,
    SideSortIconButtonProps: RightSortIconButtonProps,
    SortIconProps: SortIconProps,
    SideSortIconProps: RightSortIconProps
  })), renderStatus && /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(_TextContent.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    "data-test-id": "right-status-text",
    component: _Text.TextVariants.h6
  }, renderStatus({
    selected: state.selectedRightValues.length,
    options: rightValues.length
  })))), /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
    md: 12
  }, /*#__PURE__*/_react["default"].createElement(List, {
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues,
    ListProps: _objectSpread(_objectSpread({}, ListProps), RightListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), RightListItemProps)
  })))))));
};

DualList.propTypes = {
  leftTitle: _propTypes["default"].node,
  rightTitle: _propTypes["default"].node,
  moveLeftTitle: _propTypes["default"].node,
  moveRightTitle: _propTypes["default"].node,
  allToLeft: _propTypes["default"].bool,
  allToRight: _propTypes["default"].bool,
  moveAllLeftTitle: _propTypes["default"].node,
  moveAllRightTitle: _propTypes["default"].node,
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  noValueTitle: _propTypes["default"].node,
  noOptionsTitle: _propTypes["default"].node,
  filterOptionsTitle: _propTypes["default"].node,
  filterValueTitle: _propTypes["default"].node,
  filterValueText: _propTypes["default"].node,
  filterOptionsText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  input: _propTypes["default"].shape({
    name: _propTypes["default"].string.isRequired
  }),
  meta: _propTypes["default"].any,
  state: _propTypes["default"].object,
  sortOptions: _propTypes["default"].func,
  filterOptions: _propTypes["default"].func,
  handleOptionsClick: _propTypes["default"].func,
  leftValues: _propTypes["default"].array,
  handleMoveRight: _propTypes["default"].func,
  handleMoveLeft: _propTypes["default"].func,
  handleClearLeftValues: _propTypes["default"].func,
  handleClearRightValues: _propTypes["default"].func,
  sortValues: _propTypes["default"].func,
  filterValues: _propTypes["default"].func,
  rightValues: _propTypes["default"].array,
  handleValuesClick: _propTypes["default"].func,
  renderStatus: _propTypes["default"].func,
  FormGroupProps: _propTypes["default"].object,
  ListProps: _propTypes["default"].object,
  LeftListProps: _propTypes["default"].object,
  RightListProps: _propTypes["default"].object,
  ListItemProps: _propTypes["default"].object,
  LeftListItemProps: _propTypes["default"].object,
  RightListItemProps: _propTypes["default"].object,
  ToolbarProps: _propTypes["default"].object,
  LeftToolbarProps: _propTypes["default"].object,
  RightToolbarProps: _propTypes["default"].object,
  FilterFieldProps: _propTypes["default"].object,
  LeftFilterFieldProps: _propTypes["default"].object,
  RightFilterFieldProps: _propTypes["default"].object,
  SortIconButtonProps: _propTypes["default"].object,
  LeftSortIconButtonProps: _propTypes["default"].object,
  RightSortIconButtonProps: _propTypes["default"].object,
  SearchIconProps: _propTypes["default"].object,
  LeftSearchIconProps: _propTypes["default"].object,
  RightSearchIconProps: _propTypes["default"].object,
  SearchIconButtonProps: _propTypes["default"].object,
  LeftSearchIconButtonProps: _propTypes["default"].object,
  RightSearchIconButtonProps: _propTypes["default"].object,
  SortIconProps: _propTypes["default"].object,
  LeftSortIconProps: _propTypes["default"].object,
  RightSortIconProps: _propTypes["default"].object,
  InternalGridProps: _propTypes["default"].object,
  ListGridProps: _propTypes["default"].object,
  LeftListGridProps: _propTypes["default"].object,
  RightListGridProps: _propTypes["default"].object,
  TitleProps: _propTypes["default"].object,
  LeftTitleProps: _propTypes["default"].object,
  RightTitleProps: _propTypes["default"].object,
  ButtonsGridProps: _propTypes["default"].object,
  ButtonsInternalFlexProps: _propTypes["default"].object,
  ButtonFlexProps: _propTypes["default"].object,
  ToRightFlexProps: _propTypes["default"].object,
  IconButtonProps: _propTypes["default"].object,
  ToRightIconButtonProps: _propTypes["default"].object,
  IconProps: _propTypes["default"].object,
  AllToRightFlexProps: _propTypes["default"].object,
  AllToRightIconButtonProps: _propTypes["default"].object,
  AllToLeftFlexProps: _propTypes["default"].object,
  AllToLeftIconButtonProps: _propTypes["default"].object,
  ToLeftFlexProps: _propTypes["default"].object,
  ToLeftIconButtonProps: _propTypes["default"].object,
  ToRightIconProps: _propTypes["default"].object,
  AllToRightIconProps: _propTypes["default"].object,
  AllToLeftIconProps: _propTypes["default"].object,
  ToLeftIconProps: _propTypes["default"].object
};
DualList.defaultProps = {
  leftTitle: 'Options',
  rightTitle: 'Selected',
  moveLeftTitle: 'Move selected to left',
  moveRightTitle: 'Move selected to right',
  moveAllRightTitle: 'Move all to right',
  moveAllLeftTitle: 'Move all to left',
  noOptionsTitle: 'No available options',
  noValueTitle: 'No selected',
  filterOptionsTitle: 'Filter options',
  filterValueTitle: 'Filter selected value',
  filterOptionsText: 'Remove your filter to see all options',
  filterValueText: 'Remove your filter to see all selected',
  options: [],
  allToLeft: true,
  allToRight: true
};

var DualListSelectWrapper = function DualListSelectWrapper(props) {
  return /*#__PURE__*/_react["default"].createElement(_dualListSelect2["default"], (0, _extends2["default"])({}, props, {
    DualListSelect: DualList
  }));
};

var _default = DualListSelectWrapper;
exports["default"] = _default;