import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import clsx from 'clsx';
import { TextInput } from "@patternfly/react-core/dist/esm/components/TextInput/TextInput.js";
import { InputGroup } from "@patternfly/react-core/dist/esm/components/InputGroup/InputGroup.js";
import { Bullseye } from "@patternfly/react-core/dist/esm/layouts/Bullseye/Bullseye.js";
import { Button } from "@patternfly/react-core/dist/esm/components/Button/Button.js";
import { ButtonVariant } from "@patternfly/react-core/dist/esm/components/Button/Button.js";
import { Flex } from "@patternfly/react-core/dist/esm/layouts/Flex/Flex.js";
import { FlexItem } from "@patternfly/react-core/dist/esm/layouts/Flex/FlexItem.js";
import { Grid } from "@patternfly/react-core/dist/esm/layouts/Grid/Grid.js";
import { GridItem } from "@patternfly/react-core/dist/esm/layouts/Grid/GridItem.js";
import { Text } from "@patternfly/react-core/dist/esm/components/Text/Text.js";
import { TextVariants } from "@patternfly/react-core/dist/esm/components/Text/Text.js";
import { TextContent } from "@patternfly/react-core/dist/esm/components/Text/TextContent.js";
import { Toolbar } from "@patternfly/react-core/dist/esm/components/Toolbar/Toolbar.js";
import { ToolbarItem } from "@patternfly/react-core/dist/esm/components/Toolbar/ToolbarItem.js";
import { ToolbarContent } from "@patternfly/react-core/dist/esm/components/Toolbar/ToolbarContent.js";
import PficonSortCommonAscIcon from "@patternfly/react-icons/dist/esm/icons/pficon-sort-common-asc-icon";
import PficonSortCommonDescIcon from "@patternfly/react-icons/dist/esm/icons/pficon-sort-common-desc-icon";
import SearchIcon from "@patternfly/react-icons/dist/esm/icons/search-icon";
import AngleDoubleLeftIcon from "@patternfly/react-icons/dist/esm/icons/angle-double-left-icon";
import AngleDoubleRightIcon from "@patternfly/react-icons/dist/esm/icons/angle-double-right-icon";
import AngleRightIcon from "@patternfly/react-icons/dist/esm/icons/angle-right-icon";
import AngleLeftIcon from "@patternfly/react-icons/dist/esm/icons/angle-left-icon";
import './dual-list-select.scss';
import DualListSelectCommon from '@data-driven-forms/common/dual-list-select';
import FormGroup from '../form-group/form-group';

var List = function List(_ref) {
  var value = _ref.value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      ListProps = _ref.ListProps,
      ListItemProps = _ref.ListItemProps,
      rest = _objectWithoutProperties(_ref, ["value", "optionClick", "noOptionsTitle", "filterValue", "filterValueText", "selectedValues", "ListProps", "ListItemProps"]);

  return /*#__PURE__*/React.createElement("div", _extends({}, ListProps, rest, {
    className: clsx('pf-c-form-control', 'pf-u-pr-sm ddorg__pf4-component-mapper__dual-list-select', ListProps.className)
  }), value.length < 1 && /*#__PURE__*/React.createElement("div", _extends({}, ListItemProps, {
    className: clsx('ddorg__pf4-component-mapper__dual-list-select-option-text', 'ddorg__pf4-component-mapper__dual-list-select-option-disabled', ListItemProps.className)
  }), filterValue ? filterValueText : noOptionsTitle), value.length > 0 && value.map(function (_ref2) {
    var value = _ref2.value,
        label = _ref2.label,
        ListItemPropsItem = _ref2.ListItemProps;
    return /*#__PURE__*/React.createElement("div", _extends({
      onClick: function onClick(e) {
        return optionClick(e, value);
      },
      key: value,
      value: value
    }, ListItemProps, ListItemPropsItem, {
      className: clsx('ddorg__pf4-component-mapper__dual-list-select-option', {
        'ddorg__pf4-component-mapper__dual-list-select-option-selected': selectedValues.includes(value)
      }, ListItemProps.className, ListItemPropsItem === null || ListItemPropsItem === void 0 ? void 0 : ListItemPropsItem.className)
    }), label);
  }));
};

List.propTypes = {
  value: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })),
  optionClick: PropTypes.func.isRequired,
  noOptionsTitle: PropTypes.node,
  filterValue: PropTypes.string,
  filterValueText: PropTypes.node,
  selectedValues: PropTypes.array,
  ListProps: PropTypes.object,
  ListItemProps: PropTypes.object
};
List.defaultProps = {
  value: [],
  ListProps: {}
};

var InternalToolbar = function InternalToolbar(_ref3) {
  var sortTitle = _ref3.sortTitle,
      onFilter = _ref3.onFilter,
      onSort = _ref3.onSort,
      sortDirection = _ref3.sortDirection,
      value = _ref3.value,
      placeholder = _ref3.placeholder,
      id = _ref3.id,
      ToolbarProps = _ref3.ToolbarProps,
      SideToolbarProps = _ref3.SideToolbarProps,
      FilterFieldProps = _ref3.FilterFieldProps,
      SideFilterFieldProps = _ref3.SideFilterFieldProps,
      SearchIconButtonProps = _ref3.SearchIconButtonProps,
      SideSearchIconButtonProps = _ref3.SideSearchIconButtonProps,
      SearchIconProps = _ref3.SearchIconProps,
      SideSearchIconProps = _ref3.SideSearchIconProps,
      SortIconButtonProps = _ref3.SortIconButtonProps,
      SideSortIconButtonProps = _ref3.SideSortIconButtonProps,
      SortIconProps = _ref3.SortIconProps,
      SideSortIconProps = _ref3.SideSortIconProps;
  return /*#__PURE__*/React.createElement(Toolbar, _extends({}, ToolbarProps, SideToolbarProps, {
    className: clsx('pf-u-p-0', 'ddorg__pf4-component-mapper__dual-list-select-toolbar', ToolbarProps && ToolbarProps.className, SideToolbarProps && SideToolbarProps.className),
    id: id
  }), /*#__PURE__*/React.createElement(ToolbarContent, {
    className: "pf-u-p-0 pf-u-pb-md"
  }, /*#__PURE__*/React.createElement(ToolbarItem, {
    className: "ddorg__pf4-component-mapper__dual-list-select-toolbar__item-grow"
  }, /*#__PURE__*/React.createElement(InputGroup, null, /*#__PURE__*/React.createElement(TextInput, _extends({
    name: "filterOptions",
    id: "filterOptions",
    type: "search",
    "aria-label": placeholder,
    onChange: onFilter,
    placeholder: placeholder,
    value: value
  }, FilterFieldProps, SideFilterFieldProps)), /*#__PURE__*/React.createElement(Button, _extends({
    variant: ButtonVariant.control,
    "aria-label": "search button"
  }, SearchIconButtonProps, SideSearchIconButtonProps), /*#__PURE__*/React.createElement(SearchIcon, _extends({}, SearchIconProps, SideSearchIconProps))))), /*#__PURE__*/React.createElement(ToolbarItem, null, /*#__PURE__*/React.createElement(Button, _extends({
    onClick: onSort,
    title: sortTitle,
    variant: "plain"
  }, SortIconButtonProps, SideSortIconButtonProps), !sortDirection ? /*#__PURE__*/React.createElement(PficonSortCommonAscIcon, _extends({
    size: "md"
  }, SortIconProps, SideSortIconProps)) : /*#__PURE__*/React.createElement(PficonSortCommonDescIcon, _extends({
    size: "md"
  }, SortIconProps, SideSortIconProps))))));
};

InternalToolbar.propTypes = {
  sortTitle: PropTypes.node,
  onFilter: PropTypes.func.isRequired,
  onSort: PropTypes.func.isRequired,
  sortDirection: PropTypes.bool,
  value: PropTypes.string,
  placeholder: PropTypes.string,
  id: PropTypes.string,
  ToolbarProps: PropTypes.object,
  SideToolbarProps: PropTypes.object,
  FilterFieldProps: PropTypes.object,
  SideFilterFieldProps: PropTypes.object,
  SearchIconProps: PropTypes.object,
  SideSearchIconProps: PropTypes.object,
  SearchIconButtonProps: PropTypes.object,
  SideSearchIconButtonProps: PropTypes.object,
  SortIconButtonProps: PropTypes.object,
  SideSortIconButtonProps: PropTypes.object,
  SortIconProps: PropTypes.object,
  SideSortIconProps: PropTypes.object
};

var DualList = function DualList(_ref4) {
  var meta = _ref4.meta,
      input = _ref4.input,
      allToRight = _ref4.allToRight,
      allToLeft = _ref4.allToLeft,
      leftTitle = _ref4.leftTitle,
      moveAllLeftTitle = _ref4.moveAllLeftTitle,
      moveAllRightTitle = _ref4.moveAllRightTitle,
      moveRightTitle = _ref4.moveRightTitle,
      moveLeftTitle = _ref4.moveLeftTitle,
      rightTitle = _ref4.rightTitle,
      label = _ref4.label,
      isRequired = _ref4.isRequired,
      helperText = _ref4.helperText,
      noValueTitle = _ref4.noValueTitle,
      noOptionsTitle = _ref4.noOptionsTitle,
      filterOptionsTitle = _ref4.filterOptionsTitle,
      filterValueTitle = _ref4.filterValueTitle,
      filterValueText = _ref4.filterValueText,
      filterOptionsText = _ref4.filterOptionsText,
      state = _ref4.state,
      description = _ref4.description,
      id = _ref4.id,
      hideLabel = _ref4.hideLabel,
      sortOptions = _ref4.sortOptions,
      filterOptions = _ref4.filterOptions,
      handleOptionsClick = _ref4.handleOptionsClick,
      leftValues = _ref4.leftValues,
      handleMoveRight = _ref4.handleMoveRight,
      handleMoveLeft = _ref4.handleMoveLeft,
      handleClearLeftValues = _ref4.handleClearLeftValues,
      handleClearRightValues = _ref4.handleClearRightValues,
      sortValues = _ref4.sortValues,
      filterValues = _ref4.filterValues,
      rightValues = _ref4.rightValues,
      handleValuesClick = _ref4.handleValuesClick,
      renderStatus = _ref4.renderStatus,
      FormGroupProps = _ref4.FormGroupProps,
      ListProps = _ref4.ListProps,
      LeftListProps = _ref4.LeftListProps,
      RightListProps = _ref4.RightListProps,
      ListItemProps = _ref4.ListItemProps,
      LeftListItemProps = _ref4.LeftListItemProps,
      RightListItemProps = _ref4.RightListItemProps,
      ToolbarProps = _ref4.ToolbarProps,
      LeftToolbarProps = _ref4.LeftToolbarProps,
      RightToolbarProps = _ref4.RightToolbarProps,
      FilterFieldProps = _ref4.FilterFieldProps,
      LeftFilterFieldProps = _ref4.LeftFilterFieldProps,
      RightFilterFieldProps = _ref4.RightFilterFieldProps,
      SearchIconProps = _ref4.SearchIconProps,
      LeftSearchIconProps = _ref4.LeftSearchIconProps,
      RightSearchIconProps = _ref4.RightSearchIconProps,
      SearchIconButtonProps = _ref4.SearchIconButtonProps,
      LeftSearchIconButtonProps = _ref4.LeftSearchIconButtonProps,
      RightSearchIconButtonProps = _ref4.RightSearchIconButtonProps,
      SortIconButtonProps = _ref4.SortIconButtonProps,
      LeftSortIconButtonProps = _ref4.LeftSortIconButtonProps,
      RightSortIconButtonProps = _ref4.RightSortIconButtonProps,
      SortIconProps = _ref4.SortIconProps,
      LeftSortIconProps = _ref4.LeftSortIconProps,
      RightSortIconProps = _ref4.RightSortIconProps,
      InternalGridProps = _ref4.InternalGridProps,
      ListGridProps = _ref4.ListGridProps,
      LeftListGridProps = _ref4.LeftListGridProps,
      RightListGridProps = _ref4.RightListGridProps,
      TitleProps = _ref4.TitleProps,
      LeftTitleProps = _ref4.LeftTitleProps,
      RightTitleProps = _ref4.RightTitleProps,
      ButtonsGridProps = _ref4.ButtonsGridProps,
      ButtonsInternalFlexProps = _ref4.ButtonsInternalFlexProps,
      ButtonFlexProps = _ref4.ButtonFlexProps,
      ToRightFlexProps = _ref4.ToRightFlexProps,
      IconButtonProps = _ref4.IconButtonProps,
      ToRightIconButtonProps = _ref4.ToRightIconButtonProps,
      IconProps = _ref4.IconProps,
      AllToRightFlexProps = _ref4.AllToRightFlexProps,
      AllToRightIconButtonProps = _ref4.AllToRightIconButtonProps,
      AllToLeftFlexProps = _ref4.AllToLeftFlexProps,
      AllToLeftIconButtonProps = _ref4.AllToLeftIconButtonProps,
      ToLeftFlexProps = _ref4.ToLeftFlexProps,
      ToLeftIconButtonProps = _ref4.ToLeftIconButtonProps,
      ToRightIconProps = _ref4.ToRightIconProps,
      AllToRightIconProps = _ref4.AllToRightIconProps,
      AllToLeftIconProps = _ref4.AllToLeftIconProps,
      ToLeftIconProps = _ref4.ToLeftIconProps;
  return /*#__PURE__*/React.createElement(FormGroup, {
    label: label,
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    description: description,
    hideLabel: hideLabel,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/React.createElement(Grid, InternalGridProps, /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, _extends({
    md: 5
  }, ListGridProps, LeftListGridProps), /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(TextContent, _extends({}, TitleProps, LeftTitleProps), /*#__PURE__*/React.createElement(Text, {
    component: TextVariants.h6
  }, leftTitle))), /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(InternalToolbar, {
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    onFilter: filterOptions,
    value: state.filterOptions,
    placeholder: filterOptionsTitle,
    id: "".concat(input.name, "-options-toolbar"),
    ToolbarProps: ToolbarProps,
    SideToolbarProps: LeftToolbarProps,
    FilterFieldProps: FilterFieldProps,
    SideFilterFieldProps: LeftFilterFieldProps,
    SearchIconProps: SearchIconProps,
    SideSearchIconProps: LeftSearchIconProps,
    SearchIconButtonProps: SearchIconButtonProps,
    SideSearchIconButtonProps: LeftSearchIconButtonProps,
    SortIconButtonProps: SortIconButtonProps,
    SideSortIconButtonProps: LeftSortIconButtonProps,
    SortIconProps: SortIconProps,
    SideSortIconProps: LeftSortIconProps
  })), renderStatus && /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, {
    "data-test-id": "left-status-text",
    component: TextVariants.h6
  }, renderStatus({
    selected: state.selectedLeftValues.length,
    options: leftValues.length
  })))), /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(List, {
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues,
    ListProps: _objectSpread(_objectSpread({}, ListProps), LeftListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), LeftListItemProps)
  })))), /*#__PURE__*/React.createElement(GridItem, _extends({
    md: 2
  }, ButtonsGridProps), /*#__PURE__*/React.createElement(Bullseye, {
    className: "ddorg__pf4-component-mapper__dual-list-select-buttons"
  }, /*#__PURE__*/React.createElement(Flex, _extends({
    direction: {
      md: 'column',
      sm: 'row'
    }
  }, ButtonsInternalFlexProps), /*#__PURE__*/React.createElement(FlexItem, _extends({}, ButtonFlexProps, ToRightFlexProps), /*#__PURE__*/React.createElement(Button, _extends({
    disabled: leftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle,
    variant: "plain"
  }, IconButtonProps, ToRightIconButtonProps), /*#__PURE__*/React.createElement(AngleRightIcon, _extends({
    size: "md"
  }, IconProps, ToRightIconProps)))), allToRight && /*#__PURE__*/React.createElement(FlexItem, _extends({}, ButtonFlexProps, AllToRightFlexProps), /*#__PURE__*/React.createElement(Button, _extends({
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle,
    variant: "plain"
  }, IconButtonProps, AllToRightIconButtonProps), /*#__PURE__*/React.createElement(AngleDoubleRightIcon, _extends({
    size: "md"
  }, IconProps, AllToRightIconProps)))), allToLeft && /*#__PURE__*/React.createElement(FlexItem, _extends({}, ButtonFlexProps, AllToLeftFlexProps), /*#__PURE__*/React.createElement(Button, _extends({
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle,
    variant: "plain"
  }, IconButtonProps, AllToLeftIconButtonProps), /*#__PURE__*/React.createElement(AngleDoubleLeftIcon, _extends({
    size: "md"
  }, IconProps, AllToLeftIconProps)))), /*#__PURE__*/React.createElement(FlexItem, _extends({}, ButtonFlexProps, ToLeftFlexProps), /*#__PURE__*/React.createElement(Button, _extends({
    disabled: rightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle,
    variant: "plain"
  }, IconButtonProps, ToLeftIconButtonProps), /*#__PURE__*/React.createElement(AngleLeftIcon, _extends({
    size: "md"
  }, IconProps, ToLeftIconProps))))))), /*#__PURE__*/React.createElement(GridItem, _extends({
    md: 5
  }, ListGridProps, RightListGridProps), /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(TextContent, _extends({}, TitleProps, RightTitleProps), /*#__PURE__*/React.createElement(Text, {
    component: TextVariants.h6
  }, rightTitle))), /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(InternalToolbar, {
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    onFilter: filterValues,
    value: state.filterValue,
    placeholder: filterValueTitle,
    id: "".concat(input.name, "-value-toolbar"),
    ToolbarProps: ToolbarProps,
    SideToolbarProps: RightToolbarProps,
    FilterFieldProps: FilterFieldProps,
    SideFilterFieldProps: RightFilterFieldProps,
    SearchIconProps: SearchIconProps,
    SideSearchIconProps: RightSearchIconProps,
    SearchIconButtonProps: SearchIconButtonProps,
    SideSearchIconButtonProps: RightSearchIconButtonProps,
    SortIconButtonProps: SortIconButtonProps,
    SideSortIconButtonProps: RightSortIconButtonProps,
    SortIconProps: SortIconProps,
    SideSortIconProps: RightSortIconProps
  })), renderStatus && /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, {
    "data-test-id": "right-status-text",
    component: TextVariants.h6
  }, renderStatus({
    selected: state.selectedRightValues.length,
    options: rightValues.length
  })))), /*#__PURE__*/React.createElement(GridItem, {
    md: 12
  }, /*#__PURE__*/React.createElement(List, {
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues,
    ListProps: _objectSpread(_objectSpread({}, ListProps), RightListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), RightListItemProps)
  })))))));
};

DualList.propTypes = {
  leftTitle: PropTypes.node,
  rightTitle: PropTypes.node,
  moveLeftTitle: PropTypes.node,
  moveRightTitle: PropTypes.node,
  allToLeft: PropTypes.bool,
  allToRight: PropTypes.bool,
  moveAllLeftTitle: PropTypes.node,
  moveAllRightTitle: PropTypes.node,
  label: PropTypes.node,
  isRequired: PropTypes.bool,
  helperText: PropTypes.node,
  noValueTitle: PropTypes.node,
  noOptionsTitle: PropTypes.node,
  filterOptionsTitle: PropTypes.node,
  filterValueTitle: PropTypes.node,
  filterValueText: PropTypes.node,
  filterOptionsText: PropTypes.node,
  description: PropTypes.node,
  hideLabel: PropTypes.bool,
  id: PropTypes.string,
  input: PropTypes.shape({
    name: PropTypes.string.isRequired
  }),
  meta: PropTypes.any,
  state: PropTypes.object,
  sortOptions: PropTypes.func,
  filterOptions: PropTypes.func,
  handleOptionsClick: PropTypes.func,
  leftValues: PropTypes.array,
  handleMoveRight: PropTypes.func,
  handleMoveLeft: PropTypes.func,
  handleClearLeftValues: PropTypes.func,
  handleClearRightValues: PropTypes.func,
  sortValues: PropTypes.func,
  filterValues: PropTypes.func,
  rightValues: PropTypes.array,
  handleValuesClick: PropTypes.func,
  renderStatus: PropTypes.func,
  FormGroupProps: PropTypes.object,
  ListProps: PropTypes.object,
  LeftListProps: PropTypes.object,
  RightListProps: PropTypes.object,
  ListItemProps: PropTypes.object,
  LeftListItemProps: PropTypes.object,
  RightListItemProps: PropTypes.object,
  ToolbarProps: PropTypes.object,
  LeftToolbarProps: PropTypes.object,
  RightToolbarProps: PropTypes.object,
  FilterFieldProps: PropTypes.object,
  LeftFilterFieldProps: PropTypes.object,
  RightFilterFieldProps: PropTypes.object,
  SortIconButtonProps: PropTypes.object,
  LeftSortIconButtonProps: PropTypes.object,
  RightSortIconButtonProps: PropTypes.object,
  SearchIconProps: PropTypes.object,
  LeftSearchIconProps: PropTypes.object,
  RightSearchIconProps: PropTypes.object,
  SearchIconButtonProps: PropTypes.object,
  LeftSearchIconButtonProps: PropTypes.object,
  RightSearchIconButtonProps: PropTypes.object,
  SortIconProps: PropTypes.object,
  LeftSortIconProps: PropTypes.object,
  RightSortIconProps: PropTypes.object,
  InternalGridProps: PropTypes.object,
  ListGridProps: PropTypes.object,
  LeftListGridProps: PropTypes.object,
  RightListGridProps: PropTypes.object,
  TitleProps: PropTypes.object,
  LeftTitleProps: PropTypes.object,
  RightTitleProps: PropTypes.object,
  ButtonsGridProps: PropTypes.object,
  ButtonsInternalFlexProps: PropTypes.object,
  ButtonFlexProps: PropTypes.object,
  ToRightFlexProps: PropTypes.object,
  IconButtonProps: PropTypes.object,
  ToRightIconButtonProps: PropTypes.object,
  IconProps: PropTypes.object,
  AllToRightFlexProps: PropTypes.object,
  AllToRightIconButtonProps: PropTypes.object,
  AllToLeftFlexProps: PropTypes.object,
  AllToLeftIconButtonProps: PropTypes.object,
  ToLeftFlexProps: PropTypes.object,
  ToLeftIconButtonProps: PropTypes.object,
  ToRightIconProps: PropTypes.object,
  AllToRightIconProps: PropTypes.object,
  AllToLeftIconProps: PropTypes.object,
  ToLeftIconProps: PropTypes.object
};
DualList.defaultProps = {
  leftTitle: 'Options',
  rightTitle: 'Selected',
  moveLeftTitle: 'Move selected to left',
  moveRightTitle: 'Move selected to right',
  moveAllRightTitle: 'Move all to right',
  moveAllLeftTitle: 'Move all to left',
  noOptionsTitle: 'No available options',
  noValueTitle: 'No selected',
  filterOptionsTitle: 'Filter options',
  filterValueTitle: 'Filter selected value',
  filterOptionsText: 'Remove your filter to see all options',
  filterValueText: 'Remove your filter to see all selected',
  options: [],
  allToLeft: true,
  allToRight: true
};

var DualListSelectWrapper = function DualListSelectWrapper(props) {
  return /*#__PURE__*/React.createElement(DualListSelectCommon, _extends({}, props, {
    DualListSelect: DualList
  }));
};

export default DualListSelectWrapper;