import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import useFormApi from "@data-driven-forms/react-form-renderer/use-form-api";
import FieldArray from "@data-driven-forms/react-form-renderer/field-array";
import { Bullseye } from "@patternfly/react-core/dist/esm/layouts/Bullseye/Bullseye.js";
import { FormHelperText } from "@patternfly/react-core/dist/esm/components/Form/FormHelperText.js";
import { Grid } from "@patternfly/react-core/dist/esm/layouts/Grid/Grid.js";
import { GridItem } from "@patternfly/react-core/dist/esm/layouts/Grid/GridItem.js";
import AddCircleOIcon from "@patternfly/react-icons/dist/esm/icons/add-circle-o-icon";
import CloseIcon from "@patternfly/react-icons/dist/esm/icons/close-icon";
import './final-form-array.scss';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";

var ArrayItem = function ArrayItem(_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems;

  var _useFormApi = useFormApi(),
      renderForm = _useFormApi.renderForm;

  var widths = {
    label: fields[0].label ? 5 : 0,
    field: fields[0].label ? 7 : 12
  };
  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(name, "-").concat(index),
      hideLabel: true
    });
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, {
    sm: 11
  }, /*#__PURE__*/React.createElement("hr", {
    className: "ddf-final-form-hr"
  }))), /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, {
    sm: 11
  }, editedFields.map(function (field, index) {
    return /*#__PURE__*/React.createElement(Grid, {
      key: "".concat(field.label, "-").concat(index),
      className: "ddf-final-form-array-grid"
    }, widths.label > 0 && /*#__PURE__*/React.createElement(GridItem, {
      sm: widths.label,
      key: "".concat(field.label, "-").concat(index)
    }, /*#__PURE__*/React.createElement("label", {
      htmlFor: field.name
    }, field.label, field.isRequired && /*#__PURE__*/React.createElement("span", {
      className: "pf-c-form__label-required"
    }, "*"))), /*#__PURE__*/React.createElement(GridItem, {
      sm: widths.field
    }, renderForm([field])));
  })), /*#__PURE__*/React.createElement(GridItem, {
    sm: 1
  }, length > minItems && /*#__PURE__*/React.createElement(Bullseye, null, /*#__PURE__*/React.createElement(CloseIcon, {
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    className: "ddf-final-form-group-remove-icon"
  })), length <= minItems && /*#__PURE__*/React.createElement(Bullseye, null, /*#__PURE__*/React.createElement(CloseIcon, {
    className: "ddf-final-form-group-remove-icon disabled"
  })))));
};

ArrayItem.propTypes = {
  name: PropTypes.string,
  fieldIndex: PropTypes.number.isRequired,
  fields: PropTypes.arrayOf(PropTypes.object),
  remove: PropTypes.func.isRequired,
  length: PropTypes.number,
  minItems: PropTypes.number
};

var DynamicArray = function DynamicArray(_ref2) {
  var props = _extends({}, _ref2);

  var _useFieldApi = useFieldApi(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      minItems = _useFieldApi.minItems,
      maxItems = _useFieldApi.maxItems,
      noItemsMessage = _useFieldApi.noItemsMessage,
      rest = _objectWithoutProperties(_useFieldApi, ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage"]);

  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error;
  var isError = (dirty || submitFailed) && error && typeof error === 'string';
  return /*#__PURE__*/React.createElement(FieldArray, {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref3) {
    var _ref3$fields = _ref3.fields,
        map = _ref3$fields.map,
        _ref3$fields$value = _ref3$fields.value,
        value = _ref3$fields$value === void 0 ? [] : _ref3$fields$value,
        push = _ref3$fields.push,
        remove = _ref3$fields.remove;
    return /*#__PURE__*/React.createElement(Fragment, null, label && /*#__PURE__*/React.createElement(GridItem, {
      sm: 12
    }, label), description && /*#__PURE__*/React.createElement(GridItem, {
      sm: 12
    }, description), value.length <= 0 && /*#__PURE__*/React.createElement(Bullseye, null, /*#__PURE__*/React.createElement(GridItem, {
      sm: 12
    }, noItemsMessage)), map(function (name, index) {
      return /*#__PURE__*/React.createElement(ArrayItem, {
        key: "".concat(name, "-").concat(index),
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: remove,
        length: value.length,
        minItems: minItems
      });
    }), /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridItem, {
      sm: 11
    }, isError && /*#__PURE__*/React.createElement(FormHelperText, {
      isHidden: false,
      isError: true
    }, error)), /*#__PURE__*/React.createElement(GridItem, {
      sm: 1,
      className: "final-form-array-add-container"
    }, value.length < maxItems && /*#__PURE__*/React.createElement(Bullseye, null, /*#__PURE__*/React.createElement(AddCircleOIcon, {
      onClick: function onClick() {
        return push(defaultItem);
      },
      className: "ddf-final-form-group-add-icon"
    })), value.length >= maxItems && /*#__PURE__*/React.createElement(Bullseye, null, /*#__PURE__*/React.createElement(AddCircleOIcon, {
      className: "ddf-final-form-group-add-icon disabled"
    })))));
  });
};

DynamicArray.propTypes = {
  label: PropTypes.node,
  description: PropTypes.node,
  fields: PropTypes.arrayOf(PropTypes.object).isRequired,
  defaultItem: PropTypes.any,
  minItems: PropTypes.number,
  maxItems: PropTypes.number,
  noItemsMessage: PropTypes.node
};
DynamicArray.defaultProps = {
  maxItems: Infinity,
  minItems: 0,
  noItemsMessage: 'No items added'
};
export default DynamicArray;